/******************************************************************************
METODO DA CLASSE ATABWIDGET
CRIADO: 09-12-2008
ALTERADO: 07-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef ATABWIDGET_H
#define ATABWIDGET_H

#include <QtGui>
#include <QTabWidget>

#include "readbiblia.h"
#include "readpesquisa.h"
#include "readpassagens.h"
#include "readestudos.h"
#include "ferramentas.h"
#include "const.h"


class ATabWidget : public QTabWidget
{
    Q_OBJECT

public:
	ATabWidget(QWidget* wgt);

	QAction* actFecharAba;
	QToolButton *btnFecharAba;

	//Metdos normais
	QString limitaTamanhoTitulo(const QString &strTitulo);

private:
	Ferramentas ferramentas;
	bool moverAbas(int index1, int index2);
	int m_clickedItem;

protected:
	bool eventFilter(QObject *obj, QEvent *event);

public slots:
	//Menus
	void gerarAbas(ReadBiblia* read);
	void gerarAbas(ReadPesquisa* read);
	void gerarAbas(ReadPassagens* read);
	void gerarAbas(ReadEstudos* read);
	void renomearAba(const QString &strTitulo);
	void fecharAba();
	void fecharAba(int indice);
	void fecharTodasAbas();

};

#endif

