/******************************************************************************
HEADER DA CLASSE BANCOUSER
CRIADO: 28-05-2008
ALTERADO: 17-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef BANCOUSER_H
#define BANCOUSER_H

#include <QtGui>
#include <QSqlDatabase>
#include <QSqlQuery>

class BancoUser : QObject
{

public:
	BancoUser();
	virtual ~BancoUser();
	QSqlDatabase db;

	void openDb();
	void closeDb();

	//Estudos
	bool existEstudo(const QString &categoria, const QString &titulo);
	QString getConteudoEstudo(const QString &categoria, const QString &titulo);
	QString getAutorEstudo(const QString &categoria, const QString &titulo);
	QString getDataEstudo(const QString &categoria, const QString &titulo);
	QString getRevisorEstudo(const QString &categoria, const QString &titulo);
	QString getDataRevisaoEstudo(const QString &categoria, const QString &titulo);
	QStringList getCategoriasEstudo();
	QStringList getTitulosEstudo(const QString &categoria);
	void setEstudo(const QString &categoria, const QString &titulo, 
                   const QString &conteudo, const QString &autor, 
                   const QString &data, const QString &revisor, 
                   const QString &datar);
	void editEstudo(const QString &categoriaAntiga, const QString &tituloAntigo,
                    const QString &categoria, const QString &titulo, 
                    const QString &conteudo, const QString &autor, 
                    const QString &data, const QString &revisor, 
                    const QString &datar);
	void delEstudo(const QString &categoria, const QString &titulo);

	//Anotaes
	bool existAnotacao(const QString &livro, const QString &capitulo);
	QString getAnotacao(const QString &livro, const QString &capitulo);
	QStringList getListLivroAnotacao();
	QStringList getListCapituloAnotacao(const QString &livro);
	void editAnotacao(const QString &livro, const QString &capitulo, const QString &conteudo);
	void setAnotacao(const QString &livro, const QString &capitulo, const QString &conteudo);
	void delAnotacao(const QString &livro, const QString &capitulo);
	
	//Estado Abas
	void setEstadoAbas(int id, const QString tipo, const QString texto1, const QString texto2, 
						const QString texto3, int numerico1, int numerico2);
	QStringList getEstadoAbas(int id);
	void delEstadoAbas();
	int maxEstadoAbas();
	
private:
	void _criarTabelas();
};
#endif

