/******************************************************************************
CLASSE EXPORTAR
CRIADO: 06-06-2008
ALTERADO: 16-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "exportar.h"

Exportar::Exportar():QObject(){
}

Exportar::Exportar(const QString &file):QObject(){
	dbEmbarcado = QSqlDatabase::addDatabase("QSQLITE", "embarcado"); 
	dbEmbarcado.setHostName("embarcado");
	dbEmbarcado.setDatabaseName(file);
	dbEmbarcado.open();

	QSqlQuery query(dbEmbarcado);
	//Estudos
	query.exec("CREATE TABLE estudos(id int, categoria varchar(128), titulo varchar(256), "
	"conteudo varchar, autor varchar(128), data varchar(15), revisor varchar, "
	"datar varchar(15));");
	//Anotaes
	query.exec("CREATE TABLE anotacoes(id int, livro varchar(30), capitulo varchar(5), conteudo varchar);");
	//Controle
	query.exec("CREATE TABLE controle(qtdEstudos int);");
}
/****************************************************************************************************************************
ESTUDOS
****************************************************************************************************************************/
void Exportar::exportarUmEstudo(const QString &categoria, const QString &titulo){
	BancoUser bancoUser;
	QString conteudo = bancoUser.getConteudoEstudo(categoria, titulo);
	QString autor = bancoUser.getAutorEstudo(categoria, titulo);
	QString data = bancoUser.getDataEstudo(categoria, titulo);
	QString revisor = bancoUser.getRevisorEstudo(categoria, titulo);
	QString datar = bancoUser.getDataRevisaoEstudo(categoria, titulo);
	QSqlQuery query(dbEmbarcado);

	query.prepare("INSERT INTO estudos(id, categoria, titulo, conteudo, autor, data, revisor, datar) "
				"VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
	query.addBindValue(1);
	query.addBindValue(categoria);
	query.addBindValue(titulo);
	query.addBindValue(conteudo);
	query.addBindValue(autor);
	query.addBindValue(data);
	query.addBindValue(revisor);
	query.addBindValue(datar);
	query.exec();

	query.prepare("INSERT INTO controle(qtdEstudos) VALUES (?)");
	query.addBindValue(1);
	query.exec();

}
void Exportar::exportarEstudos(){
	int qtd = 1, i, j;
	QStringList titulos;
	QStringList categorias;
	QString categoria, titulo;
	QString conteudo;
	QString autor;
	QString data;
	QString revisor;
	QString datar;
	BancoUser bancoUser;
	QSqlQuery query(dbEmbarcado);

	categorias = bancoUser.getCategoriasEstudo();

	for (i = 0; i < categorias.size(); i++){
		categoria = categorias.at(i);
		titulos = bancoUser.getTitulosEstudo(categoria);
		for (j = 0; j < titulos.size(); j++){
			titulo = titulos.at(j);
			conteudo = bancoUser.getConteudoEstudo(categoria, titulo);
			autor = bancoUser.getAutorEstudo(categoria, titulo);
			data = bancoUser.getDataEstudo(categoria, titulo);
			revisor = bancoUser.getRevisorEstudo(categoria, titulo);
			datar = bancoUser.getDataRevisaoEstudo(categoria, titulo);

			query.prepare("INSERT INTO estudos(id, categoria, titulo, conteudo, autor, data, revisor, datar) VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
			query.addBindValue(qtd);
			query.addBindValue(categoria);
			query.addBindValue(titulo);
			query.addBindValue(conteudo);
			query.addBindValue(autor);
			query.addBindValue(data);
			query.addBindValue(revisor);
			query.addBindValue(datar);
			query.exec();

			qtd++;
		}
	}

	query.prepare("INSERT INTO controle(qtdEstudos) VALUES (?)");
	query.addBindValue(qtd - 1);
	query.exec();
	dbEmbarcado.close();
}

bool Exportar::importarEstudos(){
	int id = 1, i;
	bool updated = false;
	QString categoria, titulo, conteudo, autor, data, revisor, datar;
	QVariant v;
	AMessageBox aMsgBox;
	QSqlQuery query(dbEmbarcado);
	BancoUser bancoUser;

	query.exec("SELECT qtdEstudos FROM controle"); 
	query.next();
	id = query.value(0).toInt();

	for (i = 1; i <= id; i++){
		v.setValue(i);
		query.exec("SELECT categoria, titulo, conteudo, autor, data, revisor, datar "
				"FROM estudos WHERE id = " + v.toString()); 
		query.next(); 
		categoria = query.value(0).toString();
		titulo = query.value(1).toString();
		conteudo = query.value(2).toString();
		autor = query.value(3).toString();
		data = query.value(4).toString();
		revisor = query.value(5).toString();
		datar = query.value(6).toString();

		if (categoria != ""){
			if (bancoUser.existEstudo(categoria, titulo)){
				if (aMsgBox.yesNo("J existe um estudo de ttulo: '" + titulo + "'"
				" pertecente  categoria '" + categoria + "' na base de dados.\n"
				"Deseja substitu-lo?","Substituir estudo"))
				bancoUser.editEstudo(categoria, titulo, categoria, titulo, conteudo, autor, data, revisor, datar);
				updated = true;
			}
			else {
				bancoUser.setEstudo(categoria, titulo, conteudo, autor, data, revisor, datar);
				updated = true;
			}
		}
		else {
			aMsgBox.ok("O arquivo selecionado para importao est corrompido!", "Arquivo corrompido");
			return updated;
		}
	}
	return updated;
}

/****************************************************************************************************************************
ANOTAES
****************************************************************************************************************************/
void Exportar::recuperarAnotacoes(){ 
//recupera anota?es a partir de arquivos usados pelas vers?es <= 1.0.13 da aBblia Software 
	QDir dir;
	QString temp, conteudo;
	BancoUser bancoUser;
	QFile fileTxt;
	QTextStream streamTxt;

	dir.setPath(DIR_RODAPE);
	dir.setFilter(QDir::Files | QDir::NoSymLinks);
	dir.setSorting(QDir::Name);

	QFileInfoList list = dir.entryInfoList();
	for (int i = 0; i < list.size(); ++i) {
		QFileInfo fileInfo = list.at(i);
		temp = fileInfo.fileName();
		fileTxt.setFileName(DIR_RODAPE + temp);
		fileTxt.open(QIODevice::ReadOnly);
		streamTxt.setDevice(&fileTxt);
		conteudo = streamTxt.readAll();
		fileTxt.flush();
		fileTxt.close();
		if (!bancoUser.existAnotacao(temp.section( "_", 0, 0), temp.section( "_", 1, 1)))
			bancoUser.setAnotacao(temp.section( "_", 0, 0), temp.section( "_", 1, 1), conteudo);
		else
			bancoUser.editAnotacao(temp.section( "_", 0, 0), temp.section( "_", 1, 1), conteudo);
	}
	
	dir.rename(DIR_RODAPE, DIR_RODAPECHECKED);
}

void Exportar::exportarAnotacoes(){
	int i, j, qtd = 1;
	QStringList livros;
	QStringList capitulos;
	QString livro, capitulo, conteudo;

	BancoUser bancoUser;
	QSqlQuery query(dbEmbarcado);

	livros = bancoUser.getListLivroAnotacao();

	for (i = 0; i < livros.size(); i++){
		livro = livros.at(i);
		capitulos = bancoUser.getListCapituloAnotacao(livro);
		for (j = 0; j < capitulos.size(); j++){
			capitulo = capitulos.at(j);
			conteudo = bancoUser.getAnotacao(livro, capitulo);

			query.prepare("INSERT INTO anotacoes(id, livro, capitulo, conteudo) VALUES (?, ?, ?, ?)");
			query.addBindValue(qtd);
			query.addBindValue(livro);
			query.addBindValue(capitulo);
			query.addBindValue(conteudo);
			query.exec();
			
			qtd++;
		}
	}
	query.exec();
	dbEmbarcado.close();
}

bool Exportar::importarAnotacoes(){
	int i, qtdId = 0;
	bool updated = false;
	QString livro, capitulo, conteudo;
	QVariant v;
	AMessageBox aMsgBox;
	BancoUser bancoUser;
	QSqlQuery query(dbEmbarcado);
	
	query.exec("SELECT MAX(id) FROM anotacoes"); 
	query.next();
	qtdId = query.value(0).toInt();
	
	for (i = 1; i <= qtdId; i++){
		v.setValue(i);
		query.exec("SELECT livro, capitulo, conteudo FROM anotacoes WHERE id = " + v.toString());
		query.next();
		livro = query.value(0).toString();
		capitulo = query.value(1).toString();
		conteudo = query.value(2).toString();
		
		if (bancoUser.existAnotacao(livro, capitulo)){
			if (aMsgBox.yesNo("J existe uma anotao em: '" + livro + ":" + capitulo + 
			"' na base de dados.\n"
			"Deseja substitu-lo?","Substituir anotao"))
			bancoUser.editAnotacao(livro, capitulo, conteudo);
			updated = true;
		}
		else {
			bancoUser.setAnotacao(livro, capitulo, conteudo);
			updated = true;
		}
	}
	return updated;
}

Exportar::~Exportar(){
	dbEmbarcado.close();
}

