/******************************************************************************
CLASSE PROMESSAS
CRIADO: 21-10-2008
ALTERADO: 31-10-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "promessas.h"

#include "bancosystem.h"

Promessas::Promessas():QWidget(){
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	
	fonte = QFont("Bitstream", FONTE_MEDIA);
	fonte.setItalic( 1 );
	lblMsgPromessas = new QLabel("",this);
	geraPromessa();
	lblMsgPromessas->setFont(fonte);
    lblMsgPromessas->setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
	lblMsgPromessas->setWordWrap(true);
}
QLabel* Promessas::getPromessa(){
	return lblMsgPromessas;
}
void Promessas::geraPromessa(){
	unsigned short int idP, idT, copie, j;
	short int inicio;
	QString textoPes, texto, numeral;
	numeral = "0123456789";

	#if defined(__linux__)
		srandom(time(NULL));
	#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
		srand(time(NULL));
	#endif

	BancoSystem bancoSystem;

	idT = rand() % 1;
	idT = 0; //temporrio
	idP = rand() % bancoSystem.getQtdPromessas(idT);

	if (!idT)
		textoPes = ferramentas.passagens(bancoSystem.getPromessa(idP, idT), VELHO_TESTAMENTO, false);
	else
		textoPes = ferramentas.passagens(bancoSystem.getPromessa(idP, idT), NOVO_TESTAMENTO, false);

	copie = inicio = 0;
	j = 0;
	texto[0] = textoPes[0];
	for(unsigned short int i = 0; i < textoPes.length(); i++){
		if (inicio == -1)
			inicio = 1;
		if (textoPes[i] == '\n')
			inicio = -1;
		if (inicio == 1){
			if (copie){
				texto[j] = textoPes[i];
				j++;
			}
			else {
				for (unsigned short int l = 0; l <= 10; l++)
					if ( textoPes[i] == numeral[l] )
						copie++;
				if (copie == 1)
					copie = 0;
				else
					copie = 1;
			}
		}
		else {
			texto[j] = textoPes[i];
			j++;
		}
	}
	lblMsgPromessas->setText(texto);
}

//Redimencionador
void Promessas::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();

	lblMsgPromessas->setGeometry( QRect( 10, 25, 100 + extraWidth, 85) );
}

