/******************************************************************************
HEADER DA CLASSE READESTUDOS
CRIADO: 28-05-2008
ALTERADO: 20-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef READESTUDOS_H
#define READESTUDOS_H

#include <QtGui>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QMdiSubWindow>
#include <string.h>

#include "read.h"
#include "const.h"
#include "config.h"
#include "resolucao.h"
#include "bancouser.h"
#include "diageditor.h"

class QPixmap;
class QLabel;
class QFont;
class QTextEdit;
class QPushButton;
class QTextDocument;

class ReadEstudos : public Read
{
   Q_OBJECT

public:
	ReadEstudos(const QString &categoriaLocal, const QString &tituloLocal, const QString &modoLocal);
	ReadEstudos();
	virtual ~ReadEstudos();

	QVariant v;

	//Detalhes
	QLineEdit* ledTitulo;
	QLineEdit* ledCategoria;
	QLineEdit* ledAutor;
	QDateEdit* dedData;
	QTextEdit* tedRevisor;
	QDateEdit* dedDataRevisao;
	QLabel* lblEstudo;
	QLabel* lblTitulo;
	QLabel* lblCategoria;
	QLabel* lblAutor;
	QLabel* lblData;
	QLabel* lblRevisor;
	QLabel* lblDataRevisao;

	//Menus
	QAction* salvar;
	QAction* actRecarregar;
	QAction* actVisualizar;
	QAction* actExibirFormatar;

	Ferramentas ferramentas;
	void resizeEvent(QResizeEvent * /*event*/);
	void closeEvent(QCloseEvent *event);
	void liberarMemoria();
	
	QString getTitulo();
	void setTitulo(const QString &strTitulo);
	QString getCategoria();
	void setCategoria(const QString &strCategoria);
	QString getModo();
	void setModo(const QString &strModo);
	bool getFormatar();
	void setFormatar(bool);
	
private:
	QString _strModo;
	QString _strCategoria;
	QString _strTitulo;
	DiagEditor* mdiSubWindow;
	bool _boolFormatar;

public slots:
	bool slotSalvar();
	void slotRecarregar();
	void slotZoomIn();
	void slotZoomOut();
	void slotZoomDefault();
	void slotModificado();
	void slotValidarModificacao();
	void slotValidarModificacao(const QString&);
	void slotVisualizar();
	void slotFormatar();
	void slotFecharFormatar();
	void slotAddFormato(const QString& valor);

signals:
	void update();
	void novaJanela(ReadEstudos *read);

};

#endif

